# Chapter 2

# install.packages("lavaan", repos = "http://www.da.ugent.be", type = "source")
library(lavaan)

# Figure 2.4

# read in data
Data <- read.csv("03-data-unstd.csv", header = FALSE)
names(Data) <- c("country", "year", "sev", "income", "educat", 
                 "age", "gini", "gdp")

# rename/rescale
Data$c <- Data$income
Data$x <- Data$age
Data$m <- Data$educat
Data$y <- Data$sev
Data$z <- log(Data$gdp * 1000)

# model
model <- '
  level: 1
    m ~ xm*x
    y ~ my*m + x + c
    c ~ x + m
 
  level: 2
    y ~ z
    m ~ zm*z
  
  # defined parameters
  ie := xm * my
  clm := zm * my
'

fit <- sem(model, data = Data, cluster = "country")
summary(fit)

# icc
lavInspect(fit, "icc")

# sample stats (h1)
lavInspect(fit, "h1"


# Figure 2.6
# can't do: random slopes!

